Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPManipulator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPManipulator.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPManipulator.cs	(revision 6177)
@@ -25,16 +25,21 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Problems.Scheduling.Encodings {
   [Item("JSSPManipulator", "A JSSP manipulation operation.")]
   [StorableClass]
-  public abstract class JSSPManipulator : SchedulingOperator, IJSSPManipulator {
+  public abstract class JSSPManipulator : JSSPOperator, IJSSPManipulator, IStochasticOperator {
     #region IJSSPManipulator Members
 
-    public ILookupParameter<JSSPEncoding> SchedulingSolutionParameter {
-      get { return (ILookupParameter<JSSPEncoding>)Parameters["SchedulingSolution"]; }
+    public ILookupParameter<IJSSPEncoding> SchedulingSolutionParameter {
+      get { return (ILookupParameter<IJSSPEncoding>)Parameters["SchedulingSolution"]; }
     }
 
     #endregion
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
 
     [StorableConstructor]
@@ -45,5 +50,6 @@
     public JSSPManipulator()
       : base() {
-        Parameters.Add(new LookupParameter<JSSPEncoding>("SchedulingEncoding", "The JSSP solution to be manipulated."));
+        Parameters.Add(new LookupParameter<IJSSPEncoding>("SchedulingSolution", "The JSSP solution to be manipulated."));
+        Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
     }
 
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPOperator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPOperator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPOperator.cs	(revision 6177)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings {
+  [Item("SchedulingOperator", "A scheduling operator.")]
+  [StorableClass]
+  public abstract class JSSPOperator : SingleSuccessorOperator, IJSSPOperator{
+    [StorableConstructor]
+    protected JSSPOperator(bool deserializing) : base(deserializing) { }
+    protected JSSPOperator(JSSPOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    #region Parameter Properties
+    public ILookupParameter<ItemList<JSSPJob>> JobsParameter {
+      get { return (ILookupParameter<ItemList<JSSPJob>>)Parameters["Jobs"]; }
+    }
+    #endregion
+
+    #region Properties
+    public ItemList<JSSPJob> Jobs {
+      get { return JobsParameter.ActualValue; }
+    }
+    #endregion
+
+    public JSSPOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<ItemList<JSSPJob>>("Jobs", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance."));
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 6177)
@@ -30,8 +30,5 @@
   [Item("JSMCrossover", "An operator which crosses two JSM representations.")]
   [StorableClass]
-  public abstract class JSMCrossover : JSSPCrossover, IStochasticOperator, IJSMOperator {
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
+  public abstract class JSMCrossover : JSSPCrossover, IJSMOperator {
 
     [StorableConstructor]
@@ -40,11 +37,10 @@
     public JSMCrossover()
       : base() {
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
     }
 
-    protected abstract JSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2);
+    public abstract IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2);
 
     public override IOperation Apply() {
-      ItemArray<JSSPEncoding> parents = ParentsParameter.ActualValue;
+      ItemArray<IJSSPEncoding> parents = ParentsParameter.ActualValue;
 
       ChildParameter.ActualValue =
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 6177)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Crossovers {
+  [Item("JSM Jobbased Order Crossover", "Represents a crossover operation swapping subsequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class JSMJOXCrossover : JSMCrossover {
+    [StorableConstructor]
+    protected JSMJOXCrossover(bool deserializing) : base(deserializing) { }
+    protected JSMJOXCrossover(JSMJOXCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMJOXCrossover(this, cloner);
+    }
+
+    public JSMJOXCrossover() : base() { }
+
+    public static IJSSPEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      JSMEncoding result = new JSMEncoding();
+
+      int nrOfResources = parent1.JobSequenceMatrix.Count;
+      int nrOfJobs = parent1.JobSequenceMatrix[0].Length;
+
+      //Determine randomly which jobindexes persist
+      BoolArray persist = new BoolArray(nrOfJobs);
+      for (int i = 0; i < persist.Length; i++) {
+        persist[i] = random.Next(2) == 1;
+      }
+
+      //Fill childmatrix with values
+      for (int resIndex = 0; resIndex < nrOfResources; resIndex++) {
+        result.JobSequenceMatrix.Add(new Permutation (PermutationTypes.Absolute, nrOfJobs));
+        int parent2index = 0;
+        for (int jobIndex = 0; jobIndex < nrOfJobs; jobIndex++) {
+          if (persist[parent1.JobSequenceMatrix[resIndex][jobIndex]])
+            result.JobSequenceMatrix[resIndex][jobIndex] = parent1.JobSequenceMatrix[resIndex][jobIndex];
+          else {
+            while (persist[parent2.JobSequenceMatrix[resIndex][parent2index]])
+              parent2index++;
+            result.JobSequenceMatrix[resIndex][jobIndex] = parent2.JobSequenceMatrix[resIndex][parent2index];
+            parent2index++;
+          }
+        }
+      }
+
+      return result;
+    }
+
+    public override IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      return Cross(random, parent1, parent2);
+    } 
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMOrderCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMOrderCrossover.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMOrderCrossover.cs	(revision 6177)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Crossovers {
+  [Item("JSM Swap Crossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class JSMOrderCrossover : JSMCrossover {
+    [StorableConstructor]
+    protected JSMOrderCrossover(bool deserializing) : base(deserializing) { }
+    protected JSMOrderCrossover(JSMOrderCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMOrderCrossover(this, cloner);
+    }
+
+    public JSMOrderCrossover() : base() { }
+
+    public static IJSSPEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      JSMEncoding result = new JSMEncoding ();
+
+      for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
+        result.JobSequenceMatrix.Add (
+          HeuristicLab.Encodings.PermutationEncoding.OrderCrossover.Apply(random, 
+          parent1.JobSequenceMatrix[i], parent2.JobSequenceMatrix[i]));
+      }
+
+      return result;
+    }
+
+    public override IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      return Cross(random, parent1, parent2);
+    } 
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 6177)
@@ -27,7 +27,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Core;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Encodings.PermutationEncoding;
 
 namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Crossovers {
-  [Item("JSM Subsequence Exchange Crossover", "Represents a crossover operation swapping subsequences of the parents to generate offspring.")]
+  [Item("JSM Subsequence Exchange Crossover", "Represents a crossover operation identifiying and exchanging equal subsequences of the parents to generate offspring.")]
   [StorableClass]
   public class JSMSXXCrossover : JSMCrossover {
@@ -43,10 +45,64 @@
     public JSMSXXCrossover () : base () {}
 
-    protected override JSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
-      JSSPEncoding result = parent1;
+    public static IJSSPEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      JSMEncoding result = new JSMEncoding();
 
+      int subSequenceLength = 3;
+
+      for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
+        Permutation p1 = (Permutation)parent1.JobSequenceMatrix[i].Clone();
+        Permutation p2 = (Permutation)parent2.JobSequenceMatrix[i].Clone();
+        FindAndExchangeSubsequences(p1, p2, subSequenceLength);
+        //parent1.JobSequenceMatrix[i] = p1;
+        //parent2.JobSequenceMatrix[i] = p2;
+
+        result.JobSequenceMatrix.Add(p1);
+      }
 
       return result;
     }
+
+    private static void FindAndExchangeSubsequences(Permutation p1, Permutation p2, int subSequenceLength) {
+      for (int i = 0; i <= p1.Length - subSequenceLength; i++) {
+        for (int j = 0; j <= p2.Length - subSequenceLength; j++) {
+          int[] ss1 = GetSubSequenceAtPosition(p1, i, subSequenceLength);
+          int[] ss2 = GetSubSequenceAtPosition(p2, j, subSequenceLength);
+          if (AreEqualSubsequences(ss1, ss2)) {
+            ExchangeSubsequences(p1, i, p2, j, subSequenceLength);
+            break;
+          }
+        }
+      }
+    }
+    private static void ExchangeSubsequences(Permutation p1, int index1, Permutation p2, int index2, int subSequenceLength) {
+      Permutation aux = (Permutation)p1.Clone();
+      for (int i = 0; i < subSequenceLength; i++) {
+        p1[i + index1] = p2[i + index2];
+        p2[i + index2] = aux[i + index1];
+      }
+    }
+    private static bool AreEqualSubsequences(int[] ss1, int[] ss2) {
+      int counter = 0;
+      for (int i = 0; i < ss1.Length; i++) {
+        for (int j = 0; j < ss2.Length; j++) {
+          if (ss1[i] == ss2[j])
+            counter++;
+        }
+      }
+      return counter == ss1.Length;
+    }
+    private static int[] GetSubSequenceAtPosition(Permutation p1, int index, int subSequenceLength) {
+      int[] result = new int[subSequenceLength];
+      for (int i = 0; i < subSequenceLength; i++)
+        result[i] = p1[i + index];
+
+      return result;
+    }
+
+
+
+    public override IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      return Cross(random, parent1, parent2);
+    } 
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecoder.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecoder.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecoder.cs	(revision 6177)
@@ -35,5 +35,5 @@
   [Item("Job Sequencing Matrix Decoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequencing Matrix.")]
   [StorableClass]
-  public class JSMDecoder : NamedItem {
+  public class JSMDecoder : JSSPDecoder<JSMEncoding>, IStochasticOperator {
     [StorableConstructor]
     protected JSMDecoder(bool deserializing) : base(deserializing) { }
@@ -41,4 +41,6 @@
       : base(original, cloner) {
         this.resultingSchedule = cloner.Clone(original.resultingSchedule);
+        this.decodingErrorPolicy = original.decodingErrorPolicy;
+        this.forcingStrategy = original.forcingStrategy;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -46,47 +48,22 @@
     }
 
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
     [Storable]
     private Schedule resultingSchedule;
 
     [Storable]
-    private IRandom random;
-
-    public JSMDecoder(IntValue nrOfResources, IRandom r)
+    private JSMDecodingErrorPolicyTypes decodingErrorPolicy = JSMDecodingErrorPolicyTypes.GuidedPolicy;
+
+    [Storable]
+    private JSMForcingStrategyTypes forcingStrategy = JSMForcingStrategyTypes.ShiftForcing;
+
+    public JSMDecoder()
       : base() {
-      resultingSchedule = new Schedule(nrOfResources);
-      random = r;
-    }
-
-
-    public Schedule CreateScheduleFromJSM(ItemList<JSSPJob> jobs, ItemList<Permutation> jobSequenceMatrix) {
-      //Reset scheduled tasks in result
-      foreach (JSSPJob j in jobs) {
-        foreach (JSSPTask t in j.Tasks) {
-          t.IsScheduled.Value = false;
-        }
-      }
-
-      //GT-Algorithm
-      //STEP 0 - Compute a list of "earliest operations"
-      ItemList<JSSPTask> earliestTasksList = GetEarliestNotScheduledTasks(jobs);
-      while (earliestTasksList.Count > 0) {
-        //STEP 1 - Get earliest not scheduled operation with minimal earliest completing time
-        JSSPTask minimal = GetTaskWithMinimalEC(earliestTasksList);
-
-        //STEP 2 - Compute a conflict set of all operations that can be scheduled on the machine the previously selected operation runs on
-        ItemList<JSSPTask> conflictSet = GetConflictSetForTask(minimal, earliestTasksList);
-
-        //STEP 3 - Select an operation from the conflict set (various methods depending on how the algorithm should work..)
-        JSSPTask selectedTask = SelectTaskFromConflictSet(minimal.ResourceNr, conflictSet, jobSequenceMatrix);
-
-        //STEP 4 - Adding the selected operation to the current schedule
-        AddTaskToSchedule(selectedTask);
-
-        //STEP 5 - Back to STEP 1
-        earliestTasksList = GetEarliestNotScheduledTasks(jobs);
-      }
-
-      return resultingSchedule;
-    }
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+    }
+
     private ItemList<JSSPTask> GetEarliestNotScheduledTasks(ItemList<JSSPJob> jobs) {
       ItemList<JSSPTask> result = new ItemList<JSSPTask>();
@@ -132,5 +109,5 @@
         IntValue solutionCandidateJobNr = new IntValue(jsm[conflictedResource.Value][progressOnResource.Value]);
         foreach (JSSPTask t in conflictSet) {
-          if (t.Job.JobIndex == solutionCandidateJobNr)
+          if (t.Job.Index.Value == solutionCandidateJobNr.Value)
             result = t;
         }
@@ -141,17 +118,45 @@
       //Repairing happens here
       if (result == null) {
-        result = conflictSet[random.Next(conflictSet.Count - 1)];
+        //Decoding Error Policy BEGIN
+        //CHOOSE OTHER RESOLUTION FOR CONFLICT SET
+        result = ApplyDecodingErrorPolicy(conflictSet);
+        //result = conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
+        //Decoding Error Policy END
+
+
+        //Determine index of new resolution
         int index = 0;
-        foreach (int jobAssignment in jsm[conflictedResource.Value]) {
-          if (jobAssignment == result.Job.JobIndex.Value)
-            break;
+        while (index < jsm[conflictedResource.Value].Length && 
+          jsm[conflictedResource.Value][index] != result.Job.Index.Value)
           index++;
-        }
-        jsm[conflictedResource.Value][index] = jsm[conflictedResource.Value][progressOnResource.Value];
-        jsm[conflictedResource.Value][progressOnResource.Value] = result.Job.JobIndex.Value;
-      }
-       
-
-      return result;
+
+
+        //Forcing Strategy BEGIN
+        ApplyForcingStrategy(jsm, conflictedResource.Value, index, progressOnResource.Value, result.Job.Index.Value);
+        
+        //ForcingStrategy END
+      }
+      return result;
+    }
+
+    private void ApplyForcingStrategy(ItemList<Permutation> jsm, int conflictedResource, int newResolutionIndex, int progressOnResource, int newResolution) {
+      //if (forcingStrategy == JSMForcingStrategyTypes.SwapForcing) {
+        //SwapForcing
+        jsm[conflictedResource][newResolutionIndex] = jsm[conflictedResource][progressOnResource];
+        jsm[conflictedResource][progressOnResource] = newResolution;
+      /*} else {
+        //ShiftForcing
+
+      } */
+    }
+
+    private JSSPTask ApplyDecodingErrorPolicy(ItemList<JSSPTask> conflictSet) {
+      //if (decodingErrorPolicy == JSMDecodingErrorPolicyTypes.RandomPolicy) { 
+        //Random
+        return conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
+      /*} else {
+        //Guided
+
+      }    */
     }
     private DoubleValue ComputeEarliestStartTime(JSSPTask t) {
@@ -174,4 +179,43 @@
       affectedResource.Tasks.Add(selectedTask);
     }
+
+    public override Schedule CreateScheduleFromEncoding(JSMEncoding solution) {
+      ItemList<Permutation> jobSequenceMatrix = solution.JobSequenceMatrix;
+
+      resultingSchedule = new Schedule(new IntValue(Jobs[0].Tasks.Count));
+
+      //Reset scheduled tasks in result
+      foreach (JSSPJob j in Jobs) {
+        foreach (JSSPTask t in j.Tasks) {
+          t.IsScheduled.Value = false;
+        }
+      }
+
+      //GT-Algorithm
+      //STEP 0 - Compute a list of "earliest operations"
+      ItemList<JSSPTask> earliestTasksList = GetEarliestNotScheduledTasks(Jobs);
+      while (earliestTasksList.Count > 0) {
+        //STEP 1 - Get earliest not scheduled operation with minimal earliest completing time
+        JSSPTask minimal = GetTaskWithMinimalEC(earliestTasksList);
+
+        //STEP 2 - Compute a conflict set of all operations that can be scheduled on the machine the previously selected operation runs on
+        ItemList<JSSPTask> conflictSet = GetConflictSetForTask(minimal, earliestTasksList);
+
+        //STEP 3 - Select an operation from the conflict set (various methods depending on how the algorithm should work..)
+        JSSPTask selectedTask = SelectTaskFromConflictSet(minimal.ResourceNr, conflictSet, jobSequenceMatrix);
+
+        //STEP 4 - Adding the selected operation to the current schedule
+        AddTaskToSchedule(selectedTask);
+
+        //STEP 5 - Back to STEP 1
+        earliestTasksList = GetEarliestNotScheduledTasks(Jobs);
+      }
+
+      return resultingSchedule;
+    }
+
+    public override IOperation Apply() {
+      return base.Apply();
+    } 
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecodingErrorPolicyTypes.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecodingErrorPolicyTypes.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecodingErrorPolicyTypes.cs	(revision 6177)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix {
+  public enum JSMDecodingErrorPolicyTypes {
+    RandomPolicy,
+    GuidedPolicy
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMEncoding.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMEncoding.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMEncoding.cs	(revision 6177)
@@ -29,10 +29,12 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Data;
-using HeuristicLab.Problems.Scheduling.Encodings;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Crossovers;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Manipulators;
 
 namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix {
   [Item("Job Sequencing Matrix Encoding", "Represents a solution for a standard JobShop Scheduling Problem.")]
   [StorableClass]
-  public class JSMEncoding : JSSPEncoding{
+  public class JSMEncoding : ParameterizedNamedItem, IJSSPEncoding{
     [StorableConstructor]
     protected JSMEncoding(bool deserializing) : base(deserializing) { }
@@ -52,9 +54,4 @@
     }
 
-    public override Schedule ToSchedule(IntValue nrOfResources, ItemList<JSSPJob> jobs, IRandom random) {
-      JSMDecoder decoder = new JSMDecoder(nrOfResources, random);
-      return decoder.CreateScheduleFromJSM (jobs, JobSequenceMatrix);
-    }
-
     public override string ToString() {
       StringBuilder sb = new StringBuilder();
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMForcingStrategyTypes.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMForcingStrategyTypes.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMForcingStrategyTypes.cs	(revision 6177)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix {
+  public enum JSMForcingStrategyTypes {
+    ShiftForcing,
+    SwapForcing
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMRandomCreator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMRandomCreator.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMRandomCreator.cs	(revision 6177)
@@ -64,5 +64,5 @@
       JSMEncoding solution = new JSMEncoding();
       IntValue nrOfJobs = new IntValue (Jobs.Count);
-      IntValue nrOfResources = NrOfResources;
+      IntValue nrOfResources = new IntValue (Jobs[0].Tasks.Count);
 
       for (int i = 0; i < nrOfResources.Value; i++) {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMInsertionManipulator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMInsertionManipulator.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMInsertionManipulator.cs	(revision 6177)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Manipulators {
+
+  [Item("JSM Insert Manipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
+  [StorableClass]
+  public class JSMInsertionManipulator : JSMManipulator {
+    [StorableConstructor]
+    protected JSMInsertionManipulator(bool deserializing) : base(deserializing) { }
+    protected JSMInsertionManipulator(JSMInsertionManipulator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMInsertionManipulator(this, cloner);
+    }
+
+    public JSMInsertionManipulator () : base () {}
+
+    protected override JSMEncoding Manipulate(IRandom random, JSMEncoding individual) {
+      JSMEncoding result = (JSMEncoding)individual.Clone();
+      int resourceIndex = random.Next(result.JobSequenceMatrix.Count);
+      Permutation p = result.JobSequenceMatrix[resourceIndex];
+      int seqIndex1 = random.Next(p.Length);
+      int seqIndex2 = random.Next(p.Length);
+      int aux = p[seqIndex1];
+      p[seqIndex1] = p[seqIndex2];
+      p[seqIndex2] = aux;
+      return result;
+    }
+  }
+}
